"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var nesthydrationjs_1 = __importDefault(require("nesthydrationjs"));
var NestHydrationJS = nesthydrationjs_1.default();
var Type = /** @class */ (function () {
    function Type() {
    }
    Type.prototype.withQuery = function (q) {
        var _this = this;
        return q.select(this.getSelect()).then(function (x) { return NestHydrationJS.nest(x, _this.getDefinition()); });
    };
    return Type;
}());
var alias = function (field) { return field.replace(/\./g, '_'); };
var flatten = function (arr) { return [].concat.apply([], arr); };
// tslint:disable-next-line: max-classes-per-file
var ValueType = /** @class */ (function (_super) {
    __extends(ValueType, _super);
    function ValueType(field, option) {
        var _this = _super.call(this) || this;
        _this.field = field;
        _this.option = option;
        return _this;
    }
    ValueType.of = function (field, option) {
        if (option === void 0) { option = { id: false }; }
        return new ValueType(field, option);
    };
    ValueType.prototype.getDefinition = function () {
        return { column: alias(this.field), id: this.option.id };
    };
    ValueType.prototype.getSelect = function () {
        return [this.field + " as " + alias(this.field)];
    };
    return ValueType;
}(Type));
var ArrayType = /** @class */ (function (_super) {
    __extends(ArrayType, _super);
    function ArrayType(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    ArrayType.prototype.getDefinition = function () {
        return [this.value.getDefinition()];
    };
    ArrayType.prototype.getSelect = function () {
        return this.value.getSelect();
    };
    return ArrayType;
}(Type));
var TypeType = /** @class */ (function (_super) {
    __extends(TypeType, _super);
    function TypeType(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    TypeType.prototype.getDefinition = function () {
        var _this = this;
        return Object.keys(this.value).reduce(function (prev, curr) {
            prev[curr] = _this.value[curr].getDefinition();
            return prev;
        }, {});
    };
    TypeType.prototype.getSelect = function () {
        var _this = this;
        return flatten(Object.keys(this.value).map(function (k) { return _this.value[k].getSelect(); }));
    };
    return TypeType;
}(Type));
var NullableType = /** @class */ (function (_super) {
    __extends(NullableType, _super);
    function NullableType(value) {
        var _this = _super.call(this) || this;
        _this.value = value;
        return _this;
    }
    NullableType.prototype.getDefinition = function () {
        var _this = this;
        return Object.keys(this.value).reduce(function (prev, curr) {
            prev[curr] = _this.value[curr].getDefinition();
            return prev;
        }, {});
    };
    NullableType.prototype.getSelect = function () {
        var _this = this;
        return flatten(Object.keys(this.value).map(function (k) { return _this.value[k].getSelect(); }));
    };
    return NullableType;
}(Type));
exports.nullableType = function (v) { return new NullableType(v); };
exports.type = function (v) { return new TypeType(v); };
exports.number = function (field, option) { return ValueType.of(field, option); };
exports.string = function (field, option) { return ValueType.of(field, option); };
exports.date = function (field, option) { return ValueType.of(field, option); };
exports.boolean = function (field, option) { return ValueType.of(field, option); };
exports.nullableNumber = function (field) { return ValueType.of(field, { id: false }); };
exports.nullableString = function (field) { return ValueType.of(field, { id: false }); };
exports.nullableDate = function (field) { return ValueType.of(field, { id: false }); };
exports.array = function (v) { return new ArrayType(v); };
